#include "xtop.h"

int _fd_;
char tmp[20];
int pstat;

struct _LOADAVG_ {
  float min1;
  float min5;
  float min15;
} LoadAvg;

/*
**	Function name : OpenLoadAvg
**
**	Description : apre il file loadavg
**	Input : nulla
**	Output : l'fd; 
**
**	Comment : Esce in caso di errata apertura.
**
**
**	Last Update : 16-12
*/
void OpenLoadAvg()
{ 
  
  _fd_ = open("/proc/loadavg",O_RDONLY);
  if (_fd_ == -1)
    { printf("Errore mentre tento di aprire /proc/loadavg\n");
      exit(-1);
    }
}


/*
**	Function name : CloseLoadAvg
**
**	Description : Chiude il file loadavg.
**	Input :
**	Output :
**
**	Comment :
**
**
**	Last Update : 16-12
*/
void CloseLoadAvg()
{ close (_fd_);
}


/*
**	Function name : ReadLoad
**
**	Description :
**	Input :
**	Output :
**
**	Comment :
**
**
**	Last Update :
*/
void ReadLoadAvg()
{ //char tmp[3];
  int done;
  int i;
  /*Leggo fino al punto.*/
  
  done = FALSE;
  i = 0;
  while (done == FALSE)
    { read(_fd_, &tmp[i],1);
      if (tmp[i++] == ' ')
	done = TRUE;
    }
  LoadAvg.min1 = atof(tmp);
  bzero(tmp,20);
  
  read(_fd_, &tmp,1);
  
  done = FALSE;
  i = 0;
  while (done == FALSE)
    { read(_fd_, &tmp[i],1);
      if (tmp[i++] == ' ')
	done = TRUE;
    }
  LoadAvg.min5 = atof(tmp);
  bzero(tmp,20);  
  read(_fd_, &tmp,1);
  
  done = FALSE;
  i = 0;
  while (done == FALSE)
    { read(_fd_, &tmp[i],1);
      if (tmp[i++] == ' ')
	done = TRUE;
    }
  LoadAvg.min15 = atof(tmp);
  bzero(tmp,20);
}


gint prog (gpointer data)
  {
      //gfloat pvalue;

      OpenLoadAvg();
      ReadLoadAvg();
      
      switch (pstat)
	{ case 0 : gtk_progress_bar_update (GTK_PROGRESS_BAR (data), (LoadAvg.min1*.1));
		   pstat = 1;
		   break;
		   
          case 1 : gtk_progress_bar_update (GTK_PROGRESS_BAR (data), (LoadAvg.min5*.1));
		   pstat = 2;
		   break;
		   
          case 2 : gtk_progress_bar_update (GTK_PROGRESS_BAR (data), (LoadAvg.min15*.1));
		   pstat = 0;
		   break;
		   
	}
      CloseLoadAvg();
      
      return TRUE;
  }
