/*
   *The main file
*/

#include "xtop.h"

gint ptimer;

extern gint prog (gpointer data);
extern void ReadLoadAvg();
extern void CloseLoadAvg();
extern void OpenLoadAvg();

/*
**	Function name : gint delete_event(GtkWidget *widget, gpointer data)
**
**	Description : THE gtk_function!!! Do not delete
**	Input :
**	Output :
**	Last Modification :
*/
gint delete_event(GtkWidget *widget, gpointer data)
  {
    /* Change FALSE to TRUE and the main window will be destroyed with
       * a "delete_event". */
      return (TRUE);
  }

/*
**	Function name : main(int argc, char *argv)
**
**	Description : The main function.
**	Input :
**	Output : 
**	Last Modification : 30-1
*/
main(int argc, char **argv)
{ GtkWidget *MainWindow;
  GtkWidget *vbox_Frame, *hbox_Frame;
  
  gtk_init (&argc, &argv);

  MainWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (MainWindow), "delete_event",
		      GTK_SIGNAL_FUNC (delete_event), NULL);
  gtk_signal_connect (GTK_OBJECT (MainWindow), "destroy",
		      GTK_SIGNAL_FUNC (NULL), NULL);
  gtk_container_border_width (GTK_CONTAINER (MainWindow), 2);
  
  /* Now the MainVertical Box */
  vbox_Frame = gtk_vbox_new(TRUE,2);
  gtk_container_add(GTK_CONTAINER(MainWindow), vbox_Frame);
  gtk_widget_show(vbox_Frame);
  
  /* Now the hbox for the 2 Frame */
  hbox_Frame = gtk_hbox_new(TRUE,2);
  gtk_box_pack_start(GTK_BOX(vbox_Frame), hbox_Frame, TRUE, TRUE, 2);
  gtk_widget_show(hbox_Frame);
  
  /* Now the Frames */
  LoadAvarage(hbox_Frame);
  MemoryInfo(hbox_Frame);
  LoadAvarage(hbox_Frame);
  
  /* Now show the Window */
  gtk_widget_show(MainWindow);
  
  /* Loop */
  gtk_main();
}

